/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * TGameGraph2.java
 *
 * Created on 2011-7-23, 12:22:01
 */
package sgame;

import java.awt.*;
import java.awt.font.FontRenderContext;
import java.awt.geom.*;
import java.util.ArrayList;

/**
 *
 * @author lenovo
 */
public class Graph extends javax.swing.JPanel {

    /** Creates new form TGameGraph */
    public Graph() {
        initComponents();
        createRGB();
    }
    public void getdata(java.util.List passdata, SGameEnv environment){
        datalist = passdata;
        if(datalist.isEmpty()) datalist.add(new ArrayList()); 
        data = (ArrayList)datalist.get(0);
        this.environment=environment;
    }
    @Override
    public void paintComponent(Graphics   g){
        super.paintComponent(g); 
        int numi = getImax();
        int numj = getJmax(numi-1); 
        double newx=this.getWidth();
        double newy=this.getHeight();
        if(isize!=numi||jsize!=numj||newx!=x||newy!=y){
            x = newx;
            y = newy; 
            if(isize<numi) createRGB();
            isize = numi;
            jsize = numj;
            // set x, y, xpos, ypos
            if(x>300)
                xpos=100;   
            else    
                xpos=x/5;
            if(y>300)
                ypos=60;     
            else
                ypos=y/5;
        
            drawtitles(g);  //write titles 
            drawgraph(g);  //draw graph  
            validate();
         }
    }
    
    
    private void drawtitles(Graphics g){
        Graphics2D g2 = (Graphics2D)g;
        g2.setColor(Color.BLACK); 
        g2.draw(new Line2D.Double(xpos, 2, xpos, y-ypos));  
        g2.draw(new Line2D.Double(xpos, y-ypos, x-2, y-ypos));
        g2.draw(new Line2D.Double(x-2, y-ypos, x-2, 2));
        g2.draw(new Line2D.Double(x-2, 2, xpos, 2));
        if(y>3*xpos)
            font = new Font("Serif", Font.PLAIN, (int)(xpos*0.3));
        else font = new Font("Serif", Font.PLAIN, (int)(y/12));
        g2.setFont(font); 
        FontRenderContext frc = ((Graphics2D)g).getFontRenderContext();
        int point;
        if(y>400)
            point=(int)(y/2+ypos);
        else 
            point=(int)(y-ypos);
        g2.rotate(-(3.1415926/2),(int)(xpos*0.3), point);//rotate
        g2.drawString("Accumulated rewards", (int)(xpos*0.3), point);
        g2.rotate((3.1415926/2),(int)(xpos*0.3), point);//rotate
        font = new Font("Serif", Font.PLAIN, (int)(ypos*0.5));
        g2.setFont(font); 
        frc = ((Graphics2D)g).getFontRenderContext();
        g2.drawString("Number of steps", (int)(x/2-xpos), (int)(y-5));
    }
    
    private void drawgraph(Graphics g){
        int numi=SGameEnv.totalnumber.size();
        int i=0,j;
        double oldX, oldY, newX, newY;
        double datasize;
        int zerocrossing;
        Graphics2D g2 = (Graphics2D)g;
        
        int tmp = (Integer)SGameEnv.totalnumber.get(numi-1);
        if(numi==1){
            width = tmp;
            Rmin=0;
            Rmax=0;
        }
        else
            width = width>tmp? width : tmp;
        if(Rmin>getRmin(numi-1)) Rmin=getRmin(numi-1);
        if(Rmax<getRmax(numi-1)) Rmax=getRmax(numi-1); 
        height=Rmax-Rmin;
        g2.setStroke(new BasicStroke(2.0f));
        for(i=0 ; i<numi ; i++){ 
            oldX=xpos;
            oldY=y-ypos-(0-Rmin)/height*(y-ypos-10);
            g2.setColor(new Color((Integer)ramR.get(i), (Integer)ramG.get(i), (Integer)ramB.get(i))); 
            data = (ArrayList)datalist.get(i);
            datasize=data.size();
            zerocrossing = (Integer)SGameEnv.zerocrossing.get(i);
            for(j=0 ; j<datasize ; j++){
                if((j+1)>zerocrossing&&zerocrossing!=0){
                    newX=oldX+1000/width*(x-2-xpos);
                    newY=y-ypos-((Double)data.get(j)-Rmin)/height*(y-ypos-10);
                }
                else{
                    newX=oldX+1/width*(x-2-xpos);
                    newY=y-ypos-((Double)data.get(j)-Rmin)/height*(y-ypos-10);
                }
                g2.draw(new Line2D.Double(oldX, oldY, newX, newY)); 
                font = new Font("Serif", Font.PLAIN, (int)(y/20));
                g2.setFont(font);
                g2.drawString("trend "+String.valueOf(i+1), (int)(0.5*xpos*(i/15+1)+0.7*xpos), (int)(y/20*(i%15+1)));
                oldX=newX;
                oldY=newY;
            }
        }
        if(numi>0) drawscale(g, width, height, Rmin);
    }
    
    private void drawscale(Graphics g, double width, double height, double Rmin)
    {
        int t;
        double xscale, yscale;
        float num1;
        long step, num2;
        Graphics2D g2 = (Graphics2D)g;

        //x-axis
        g2.setColor(Color.BLACK); 
        g2.setStroke(new BasicStroke(1.0f));
        xscale=xpos;
        if(width<200)
            step=10;
        else if(width<1000)
            step=20;
        else if(width<2500)
            step=50;
        else if(width<5000)
            step=100;
        else if(width<50000)
            step=500;
        else step=(long)width/20000*500;
        if((ypos*0.3)<=((x-xpos)/width*step*2.5))
            font = new Font("Serif", Font.PLAIN, (int)(ypos*0.3));
        else font = new Font("Serif", Font.PLAIN, (int)((x-xpos)/width*step*2.5));
        g2.setFont(font);
        g2.drawString(String.valueOf(0), (int)(xscale), (int)(y-5-ypos*0.5));
        for(num1=step, t=1 ; num1<=width ; num1+=step, t++){
            xscale+=(int)step/width*(x-xpos-2);
            if(t%5==0){
                g2.setStroke(new BasicStroke(2.0f));
                g2.draw(new Line2D.Double(xscale, y-ypos, xscale, y-ypos-8));
                if(step>=10000)
                    g2.drawString(String.valueOf(num1/1000000)+"M", (int)(xscale-ypos*0.4), (int)(y-5-ypos*0.5));
                else if(step>=500)
                    g2.drawString(String.valueOf(num1/1000)+"k", (int)(xscale-ypos*0.4), (int)(y-5-ypos*0.5));
                else
                    g2.drawString(String.valueOf(num1), (int)(xscale-ypos*0.4), (int)(y-5-ypos*0.5));
                g2.setStroke(new BasicStroke(1.0f));
            }   
            else g2.draw(new Line2D.Double(xscale, y-ypos, xscale, y-ypos-6));
        }
        //y-axis
        if(height<300)
            step=10;
        else if(height<2000)
            step=20;
        else if(height<5000)
            step=50;
        else if(height<10000)
            step=100;
        else if(height<50000)
            step=500;
        else step=10000;
        if((xpos*0.2)<=((y-ypos-10)/height*step*5))
            font = new Font("Serif", Font.PLAIN, (int)(xpos*0.2));
        else font = new Font("Serif", Font.PLAIN, (int)((y-ypos-10)/height*step*5));
        g2.setFont(font);
        yscale=y-ypos-(0-Rmin)/height*(y-ypos-10);
        g2.setStroke(new BasicStroke(2.0f));
        g2.draw(new Line2D.Double(xpos, yscale, xpos+8, yscale));
        g2.drawString(String.valueOf(0), (int)(xpos*0.6), (int)(yscale+xpos*0.1));
        g2.setStroke(new BasicStroke(1.0f));
        for(num2=0-step, t=1 ; num2>Rmin ; num2-=step, t++){
            yscale+=(int)step/height*(y-ypos-10);
            if(t%5==0){
                g2.setStroke(new BasicStroke(2.0f));
                g2.draw(new Line2D.Double(xpos, yscale, xpos+8, yscale));
                g2.drawString(String.valueOf(num2), (int)(xpos*0.4), (int)(yscale+xpos*0.1));
                g2.setStroke(new BasicStroke(1.0f));
            }   
            else g2.draw(new Line2D.Double(xpos, yscale, xpos+6, yscale));
        }
        yscale=y-ypos-(0-Rmin)/height*(y-ypos-10);
        for(num2=step, t=1 ; num2<height+Rmin ; num2+=step, t++){
            yscale-=(int)step/height*(y-ypos-10);
            if(t%5==0){
                g2.setStroke(new BasicStroke(2.0f));
                g2.draw(new Line2D.Double(xpos, yscale, xpos+8, yscale));
                g2.drawString(String.valueOf(num2), (int)(xpos*0.4), (int)(yscale+xpos*0.1));
                g2.setStroke(new BasicStroke(1.0f));
            }   
            else g2.draw(new Line2D.Double(xpos, yscale, xpos+6, yscale));
        }
    }
    
    private int getImax()
    {
        return datalist.size();
    }
    
    private int getJmax(int i)
    {
        ArrayList tmp = (ArrayList)datalist.get(i);
        return tmp.size();
    }
    
    private double getRmin(int i)
    {
        double reward;
        ArrayList tmp;
        int Jmax=getJmax(i);
        
        tmp=(ArrayList)datalist.get(i);
        if(!tmp.isEmpty()){
           reward = (Double)tmp.get(0);
            for(int j=0 ; j<Jmax ; j++){
                if(reward>(Double)tmp.get(j)) reward=(Double)tmp.get(j);
            }
            return reward;
        }
        else return 0;
    }
    
    private double getRmax(int i)
    {
        double reward;
        ArrayList tmp;
        int Jmax=getJmax(i);
        
        tmp=(ArrayList)datalist.get(i);
        if(!tmp.isEmpty()){
           reward = (Double)tmp.get(0);
            for(int j=0 ; j<Jmax ; j++){
                if(reward<(Double)tmp.get(j)) reward=(Double)tmp.get(j);
            }
            return reward;
        }
        else return 0;
    }
    
    private void createRGB()
    {
        ramR.add((int)(Math.random()*255));
        ramG.add((int)(Math.random()*255));
        ramB.add((int)(Math.random()*255));
    }
    
    public void reset()
    {
        Rmax=0;
        Rmin=0;
        height=0;
        width=0;
        isize=1;
        jsize=0;
        x=0;
        y=0;
        ramR.clear();
        ramG.clear();
        ramB.clear();
        createRGB();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setBackground(new java.awt.Color(255, 255, 255));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    public java.util.List datalist;
    public ArrayList data;
    private ArrayList ramR = new ArrayList();
    private ArrayList ramG = new ArrayList();
    private ArrayList ramB = new ArrayList();
    double x=0, y=0; // the current size of the panel 
    double xpos, ypos;
    private int isize=0, jsize=0;
    private Font font;
    private SGameEnv environment;
    double width=0;
    double height=0;
    double Rmin=0, Rmax=0;
}
